/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc/config/epiphany/epiphany.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_m (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 26 "../../gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 32 "../../gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 41 "../../gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 43 "../../gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 50 "../../gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 51 "../../gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 57 "../../gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 58 "../../gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 62 "../../gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 66 "../../gcc/common.md"
(CONSTANT_P (op))) && (
#line 67 "../../gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 71 "../../gcc/common.md"
(CONSTANT_P (op))) && ((
#line 72 "../../gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 73 "../../gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 77 "../../gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 78 "../../gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 82 "../../gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 83 "../../gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 89 "../../gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 90 "../../gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 95 "../../gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_U16 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return ((GET_CODE (op) == CONST_INT) && (
#line 26 "../../gcc/config/epiphany/constraints.md"
(IMM16 (ival)))) || ((GET_CODE (op) == SYMBOL_REF || GET_CODE (op) == LABEL_REF || GET_CODE (op) == CONST) && (
#line 28 "../../gcc/config/epiphany/constraints.md"
(epiphany_small16 (op))));
}
static inline bool
satisfies_constraint_K (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 33 "../../gcc/config/epiphany/constraints.md"
(IMM5 (ival)));
}
static inline bool
satisfies_constraint_L (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 40 "../../gcc/config/epiphany/constraints.md"
(SIMM11 (ival)));
}
static inline bool
satisfies_constraint_CnL (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 45 "../../gcc/config/epiphany/constraints.md"
(SIMM11 (-ival)));
}
static inline bool
satisfies_constraint_Cm1 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 50 "../../gcc/config/epiphany/constraints.md"
(SIMM11 (ival+1))) && (
#line 51 "../../gcc/config/epiphany/constraints.md"
(epiphany_m1reg >= 0)));
}
static inline bool
satisfies_constraint_Cl1 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 56 "../../gcc/config/epiphany/constraints.md"
(ival == (ival | ~(ival-1)))) && (
#line 57 "../../gcc/config/epiphany/constraints.md"
(epiphany_m1reg >= 0)));
}
static inline bool
satisfies_constraint_Cr1 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 62 "../../gcc/config/epiphany/constraints.md"
(ival == (ival & ~(ival+1)))) && (
#line 63 "../../gcc/config/epiphany/constraints.md"
(epiphany_m1reg >= 0)));
}
static inline bool
satisfies_constraint_Cal (rtx ARG_UNUSED (op))
{
  return 
#line 67 "../../gcc/config/epiphany/constraints.md"
((flag_pic
		? nonsymbolic_immediate_operand (op, VOIDmode)
		: immediate_operand (op, VOIDmode)));
}
static inline bool
satisfies_constraint_Csy (rtx ARG_UNUSED (op))
{
  return 
#line 73 "../../gcc/config/epiphany/constraints.md"
(symbolic_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_Rgs (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 98 "../../gcc/config/epiphany/constraints.md"
(REGNO (op) >= FIRST_PSEUDO_REGISTER || REGNO (op) <= 7));
}
static inline bool
satisfies_constraint_Car (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && ((
#line 104 "../../gcc/config/epiphany/constraints.md"
(RTX_OK_FOR_OFFSET_P (SImode, op))) || ((
#line 105 "../../gcc/config/epiphany/constraints.md"
(RTX_OK_FOR_OFFSET_P (HImode, op))) || (
#line 106 "../../gcc/config/epiphany/constraints.md"
(RTX_OK_FOR_OFFSET_P (QImode, op)))));
}
static inline bool
satisfies_constraint_Rra (rtx op)
{
  return (GET_CODE (op) == UNSPEC) && ((
#line 112 "../../gcc/config/epiphany/constraints.md"
(XINT (op, 1) == UNSPEC_RETURN_ADDR)) && (
#line 113 "../../gcc/config/epiphany/constraints.md"
(!MACHINE_FUNCTION (cfun)->lr_clobbered)));
}
static inline bool
satisfies_constraint_Rcc (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 118 "../../gcc/config/epiphany/constraints.md"
(REGNO (op) == CC_REGNUM));
}
static inline bool
satisfies_constraint_Sra (rtx op)
{
  return (GET_CODE (op) == UNSPEC) && (
#line 124 "../../gcc/config/epiphany/constraints.md"
(XINT (op, 1) == UNSPEC_RETURN_ADDR));
}
static inline bool
satisfies_constraint_Cfm (rtx op)
{
  return (GET_CODE (op) == CONST) && ((
#line 129 "../../gcc/config/epiphany/constraints.md"
(GET_CODE (XEXP (op, 0)) == UNSPEC)) && (
#line 130 "../../gcc/config/epiphany/constraints.md"
(XINT (XEXP (op, 0), 1) == UNSPEC_FP_MODE)));
}
#endif /* tm-constrs.h */
